#include <STC8G.H>
#include "define.h"
#include <intrins.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#define		RXD		P30
#define		TXD		P31
#define		SCL		P32
#define		SDA		P33
#define		FOSC		11059200UL
#define		BAUD		9600UL
#define		BRT			(0x10000-FOSC/BAUD/4)
#define		T_Buffer_Len	64	//Uart1ͻ泤
#define		R_Buffer_Len	64	//Uart1ջ泤

unsigned char		RP;							//Uart1ָ
unsigned char		TP;							//Uart1ָ
unsigned char		Uart_Send_Lenth;			//Uart1ͳ
unsigned char xdata	R_Buffer[R_Buffer_Len];		//Uart1ջ
unsigned char xdata	T_Buffer[T_Buffer_Len];		//Uart1ͻ
bit I2C_Busy;
unsigned char Temp[6];
float Tem,Hum;

/*----------------------------ʱ10us@STC-Y6@11.0592MHz----------------------------*/
void Delay_10us(void)
{
	unsigned char i;
	i=35;
	while(--i);
}

/*----------------------------ʱx10us----------------------------*/
void Delay_x10us(unsigned char x)
{
	while(x--)
		Delay_10us();
}

///*----------------------------ʱ10ms@STC-Y6@11.0592MHz----------------------------*/
//void Delay_10ms(void)
//{
//	unsigned char i,j;
//	_nop_();
//	_nop_();
//	i=144;
//	j=157;
//	do
//	{
//		while(--j);
//	}while(--i);
//}

///*----------------------------ʱx10ms----------------------------*/
//void Delay_x10ms(unsigned char x)
//{
//	while(x--)
//		Delay_10ms();
//}

void UART_Send(unsigned int x)
{
	TP=0;
	Uart_Send_Lenth=x;
	TI=1;
}

void Uart_Printf(unsigned char *v,...)
{
	va_list ap;
	va_start(ap,v);
	UART_Send(vsprintf(T_Buffer,v,ap));
	va_end(ap);
}

void I2C_Start(void)
{
	I2C_Busy=1;
	I2CMSCR=0x81;
	while(I2C_Busy);
}

void I2C_SendData(unsigned char dat)
{
	I2CTXD=dat;
	I2C_Busy=1;
	I2CMSCR=0x82;
	while(I2C_Busy);
}

void I2C_RecvACK(void)
{
	I2C_Busy=1;
	I2CMSCR=0x83;
	while(I2C_Busy);
}

unsigned char I2C_RecvData(void)
{
	I2C_Busy=1;
	I2CMSCR=0x84;
	while(I2C_Busy);
	return I2CRXD;
}

void I2C_SendACK(void)
{
	I2CMSST=0x00;
	I2C_Busy=1;
	I2CMSCR=0x85;
	while(I2C_Busy);
}

void I2C_SendNAK(void)
{
	I2CMSST=0x01;
	I2C_Busy=1;
	I2CMSCR=0x85;
	while(I2C_Busy);
}

void I2C_Stop(void)
{
	I2C_Busy=1;
	I2CMSCR=0x86;
	while(I2C_Busy);
}

unsigned char CRC8(unsigned char *p,unsigned char num)
{
	unsigned char i,j;
	unsigned char crc=0xFF;
	for(j=0;j<num;j++)
	{
		crc^=(p[j]);
		for(i=8;i>0;--i)
		{
			if(crc&0x80) 
				crc=(crc<<1)^0x31;
			else 
				crc=(crc<<1);
		}
	}
	return crc;
}

bit SHT30_CRC(unsigned char *p,unsigned char num,unsigned char dat)
{
	unsigned char crc;
	crc=CRC8(p,num);
	if(crc!=dat)
	{   
		return 0;
	}
	return 1;
}

bit SHT30_Read(unsigned char *p,unsigned char i)
{
	bit x;
	I2C_Start();
	I2C_SendData(0x88);
	I2C_RecvACK();
	I2C_SendData(0xE0);
	I2C_RecvACK();
	I2C_SendData(0x00);
	I2C_RecvACK();
	I2C_Stop();
	Delay_x10us(100);
	I2C_Start();
	I2C_SendData(0x89);
	I2C_RecvACK();
	x=!(I2CMSST&MSACKI);
	if(x)
	{
		do
		{
			*p=I2C_RecvData();
			p++;
			if(i!=1)
				I2C_SendACK();
		}
		while(--i);
		I2C_SendNAK();
	}
	I2C_Stop();
	return x;
}

bit SHT30_Calc(void)
{
	bit x;
	unsigned char i;
	unsigned char temp[3];
	unsigned int tem,hum;
	x=SHT30_Read(Temp,6);
	if(x)
	{
		for(i=0;i<3;i++)
		{
			temp[i]=Temp[i];
		}
		if(SHT30_CRC(temp,2,temp[2]))
		{
			tem=((temp[0]<<8)|temp[1]);
			Tem=(175.0F*(float)tem/65535.0F-45.0F);//Tem=-45+175*tem/(2^16-1)
		}
		for(i=0;i<3;i++)
		{
			temp[i]=Temp[i+3];
		}
		if(SHT30_CRC(temp,2,temp[2]))
		{
			hum=((temp[0]<<8)|temp[1]);
			Hum=(100.0F*(float)hum/65535.0F);//Hum=hum*100/(2^16-1)
		}
	}
	return x;
}

void SHT30_Init(void)
{
	I2C_Start();
	I2C_SendData(0x88);
	I2C_RecvACK();
	I2C_SendData(0x30);
	I2C_RecvACK();
	I2C_SendData(0xA2);
	I2C_RecvACK();
	I2C_Stop();
	Delay_x10us(100);
	I2C_Start();
	I2C_SendData(0x88);
	I2C_RecvACK();
	I2C_SendData(0x21);
	I2C_RecvACK();
	I2C_SendData(0x30);
	I2C_RecvACK();
	I2C_Stop();
	Delay_x10us(100);
}

void Init(void)
{
	P_SW2|=EAXFR;
	
	P3M0=0x00;
	P3M1=0x00;
	P5M0=0x00;
	P5M1=0x00;
	P3PU=0x0c;
	
	AUXR=0x40;		//öʱ0ʱΪ12Tģʽöʱ1Ϊ1Tģʽöʱ1Ϊʷ
	TMOD=0x01;		//öʱ0Ϊ16λԶװģʽöʱ1Ϊ16λԶװģʽ
	TL0=0x00;		//öʱ0ʼֵ5ms
	TH0=0xEE;		//öʱ0ʼֵ5ms
	TF0=0;			//TF0жϱ־λ
	ET0=1;			//öʱ0ж
	
	SCON=0x50;		//UART1ģʽΪ8λݿɱ䲨
	TL1=BRT;		//UART1
    TH1=BRT>>8;		//UART1
	TR1=1;			//򿪶ʱ1
	ES=1;			//UART1ж
	
	I2CCFG=0xC6;	//345.6K@11.0592M
	I2CMSCR=EMSI;
	I2CMSST=0x00;
	
	EA=1;			//ж
	
	SHT30_Init();
}

void main(void)
{
	Init();
	while(1)
	{
		if(SHT30_Calc())
			Uart_Printf("T=%2.2f H=%2.2f%%\r\n",Tem,Hum);
	}
}

void Uart_Start(void)
{
	TL0=0x00;
	TH0=0xEE;
	TR0=1;
}

void Uart_Stop(void)
{
	TR0=0;
	TL0=0x00;
	TH0=0xEE;
	RP=0;
	memset(R_Buffer,0x00,sizeof R_Buffer);
}

void Timer0_Isr(void) interrupt 1 
{
	Uart_Stop();
}

void Uart_Isr(void) interrupt 4
{
	if(RI)
	{
		RI=0;
		Uart_Start();
		R_Buffer[RP]=SBUF;
		if(RP==R_Buffer_Len-1)
		{
			Uart_Stop();
		}
		else if(TR0)
		{
			RP++;
		}
	}
	if(TI)
	{
		TI=0;
		if(Uart_Send_Lenth!=0)
		{
			SBUF=(T_Buffer[TP]);
			TP++;
		}
		if(TP==Uart_Send_Lenth)
		{
			TP=0;
			Uart_Send_Lenth=0;
		}
	}
}

void I2C_Isr(void) interrupt 24
{
	_push_(P_SW2);
	P_SW2|=EAXFR;
	if(I2CMSST&MSIF)
	{
		I2CMSST&=~MSIF;
		I2C_Busy=0;
	}
	_pop_(P_SW2);
}